sub parse {
    my( $str ) = @_;
    my @res = ();
    my $buff = "";

    while( $str =~ /^([^\s\t\"\']*)([\s\t]+|[\"\'])/s ) {
	my( $arg, $sep ) = ($1,$2,$');
	$str = $';

	if( $sep =~ /[\s\t]/ ) {
	    push( @res, $buff.$arg );
	    $buff = "";
	}
	else {
	    $buff .= $arg;
	    if( $str =~ /^(.*?)\Q$sep\E/s ) {
		$buff .= $1;
		$str = $';
	    }
	    else {
		$buff .= $str;
		$str = "";
	    }
	    if( $str =~ /^[\s\t]+/s ) {
		$str = $';
		push( @res, $buff );
		$buff = "";
	    }

	}
    }
    $str = $buff.$str;
    push( @res, $str ) if( $str );
    return @res;
}

1;
